import Flutter
import attestr_flowx


public class SwiftAttestrFlowxPlugin: NSObject, FlutterPlugin {

    private var attestrDelegate = AttestrFlowxDelegate()

    public static func register(with registrar: FlutterPluginRegistrar) {
        let channel = FlutterMethodChannel(name: "attestr_flowx_plugin", binaryMessenger: registrar.messenger())
        let instance = SwiftAttestrFlowxPlugin()
        registrar.addMethodCallDelegate(instance, channel: channel)
    }

    public func handle(_ call: FlutterMethodCall, result: @escaping FlutterResult) {
        switch call.method {
        case "initiateSession":
            let options = call.arguments as! Dictionary<String, Any>
            attestrDelegate.launchFlow(options: options, result: result)
        default:
            print("No such method")
        }
    }
}
