import 'package:flutter_test/flutter_test.dart';
import 'package:attestr_flowx_plugin/attestr_flowx_plugin.dart';
import 'package:attestr_flowx_plugin/attestr_flowx_plugin_platform_interface.dart';
import 'package:attestr_flowx_plugin/attestr_flowx_plugin_method_channel.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';

class MockAttestrFlowxPluginPlatform 
    with MockPlatformInterfaceMixin
    implements AttestrFlowxPluginPlatform {

  @override
  Future<String?> getPlatformVersion() => Future.value('42');
}

void main() {
  final AttestrFlowxPluginPlatform initialPlatform = AttestrFlowxPluginPlatform.instance;

  test('$MethodChannelAttestrFlowxPlugin is the default instance', () {
    expect(initialPlatform, isInstanceOf<MethodChannelAttestrFlowxPlugin>());
  });

  test('getPlatformVersion', () async {
    AttestrFlowxPlugin attestrFlowxPlugin = AttestrFlowxPlugin();
    MockAttestrFlowxPluginPlatform fakePlatform = MockAttestrFlowxPluginPlatform();
    AttestrFlowxPluginPlatform.instance = fakePlatform;
  
    expect(await attestrFlowxPlugin.getPlatformVersion(), '42');
  });
}
